import hashlib
import time
import os
import urllib

import random
try:
	random = random.SystemRandom()
	sysrandom = True
except NotImplementedError:
	sysrandom = False


def get_random_string(length=12, allowed_chars='abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789'):
	"""This is the same function used to generate Django's SECRET_KEYs"""
	if not sysrandom:
		random.seed(hashlib.sha256(("%s%s%s" % (random.getstate(), time.time(), '')).encode('utf-8')).digest())
	return ''.join([random.choice(allowed_chars) for _ in range(length)])


def modify_file(name, directory, contents=None):
	if not contents:
		contents = []

	filename = os.path.join(directory, name)
	with open(filename, 'a') as txt:
		for line in contents:
			txt.write(line)
			txt.write('\n')


def store_gitignore(lang, directory):
	urllib.urlretrieve('https://raw.githubusercontent.com/github/gitignore/master/' + lang + '.gitignore', os.path.join(directory, '.gitignore'))
